// * Import (require) `connection.js` into `orm.js`
const connection = require("../config/connection.js");

//    * In the `orm.js` file, create the methods that will execute the necessary MySQL commands in the controllers. These are the methods you will need to use in order to retrieve and store data in your database.
// function printQuestionMarks(num) {
//     const arr = [];
  
//     for (let i = 0; i < num; i++) {
//       arr.push("?");
//     }
  
//     return arr.toString();
//   }
  
  // Helper function to convert object key/value pairs to SQL syntax
  function objToSql(ob) {
    let arr = [];
  
    // loop through the keys and push the key/value as a string int arr
    for (let key in ob) {
      let value = ob[key];
      // check to skip hidden properties
      if (Object.hasOwnProperty.call(ob, key)) {
        // if string with spaces, add quotations (Lana Del Grey => 'Lana Del Grey')
        if (typeof value === "string" && value.indexOf(" ") >= 0) {
          value = "'" + value + "'";
        }
        // e.g. {name: 'Lana Del Grey'} => ["name='Lana Del Grey'"]
        // e.g. {devoured: true} => ["devoured=true"]
        arr.push(key + "=" + value);
      }
    }
      // translate array of strings to a single comma-separated string
    return arr.toString();
  }
  //      * `selectAll()`
  // Object for all our SQL statement functions.
  let orm = {
    all: function(tableInput, cb) {
      let queryString = "SELECT * FROM " + tableInput + ";";
      connection.query(queryString, function(err, result) {
        if (err) {
            console.log(err)
          throw err;
        }
        cb(result);
      });
    },


    create: function(table, cols, vals, cb) {
     let queryString = 'INSERT INTO ' + table; //     * `insertOne()`
  
      queryString += ' (';
      queryString += cols.toString();
      queryString += ') ';
      queryString += 'VALUES (';
      queryString += `'${vals.toString()}'`;
      queryString += ');';
  
      console.log(queryString);
  
      connection.query(queryString, vals, function(err, result) {
        if (err) {
            console.log(err)
          throw err;
        }
  
        cb(result);
      });
    },
    // An example of objColVals would be {name: chili burger, devoured: true}
    //      * `updateOne()`
    update: function(table, objColVals, condition, cb) {
      let queryString = "UPDATE " + table;

      queryString += " SET ";
      queryString += objToSql(objColVals);
      queryString += " WHERE ";
      queryString += condition;
  
      console.log(queryString);
      connection.query(queryString, function(err, result) {
        if (err) {
            console.log(err)
          throw err;
        }
  
        cb(result);
      });
    },
    delete: function(table, condition, cb) {
      let queryString = "DELETE FROM " + table;
      queryString += " WHERE ";
      queryString += condition;
  
      connection.query(queryString, function(err, result) {
        if (err)  {
            console.log(err)
          throw err;
        }
        cb(result);
      });
    }
  };
  
//    * Export the ORM object in `module.exports`.
module.exports = orm;